
//edited for hunger scripts

const string heal_id = "heal command";

void onInit( CBlob@ this )
{
	if (!this.exists( "eat sound" )) {
		this.set_string( "eat sound", "/Eat.ogg" );
	}
	
	this.addCommandID(heal_id);
}
void onTick(CBlob@ this)
{
	AttachmentPoint@ point = this.getAttachments().getAttachmentPointByName("PICKUP");
	CBlob@ holder = point.getOccupied();
	if (holder !is null)
	{
		if(holder.isKeyPressed(key_action1))
		{	
			CBlob@ blob = holder;
			Heal( this, blob );
		}
	}
}
void Heal( CBlob@ this, CBlob@ blob )
{
		if (getNet().isServer() && blob.hasTag("player") && !this.hasTag("healed")) 
		{
			CBitStream params;
			params.write_u16(blob.getNetworkID());
		
			u8 heal_amount = 255; //in quarter hearts, 255 means full hp
			u8 hunger_restore = 50;
			u8 thirst_restore = 0;
			// Setting different types of eatables!
			// TODO: Create a berry that makes you lose hunger and HP.
			//
			//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
			if ( this.getName() == "heart" )	  // HACK
			{
				heal_amount = 4;
				hunger_restore = 0;//we arent canibals!  
			}
			else if (this.getName() == "WaterFlask")
			{
				hunger_restore = 0;
				heal_amount = 0;
				thirst_restore = 30;
			}
			else if (this.getName() == "PotionOfSatiation") // Hungry Pot
			{
				hunger_restore = 100;
				heal_amount = 0;
				thirst_restore = 0;
			}
			else if (this.getName() == "PotionOfThirstQuench") // Thirsty Pot
			{
				hunger_restore = 0;
				heal_amount = 0;
				thirst_restore = 100;
			}
			else if (this.getName() == "PotionOfHealth") //HP pot
			{
				hunger_restore = 0;
				heal_amount = 255;
				thirst_restore = 0;
			}
			// End of food stuffs

			//Thirst stuff
			u8 current_thirst = blob.get_u8("thirst_current");
			u8 restored_thirst = current_thirst + thirst_restore;

			if (restored_thirst > blob.get_u8("thirst_max")) //error fixing
			{
				restored_thirst = blob.get_u8("thirst_max");
			}
			//hunger
			u8 current = blob.get_u8("hunger_current");
			u8 restored = current + hunger_restore;
			if (restored > blob.get_u8("hunger_max")) //error fixing
			{
				restored = blob.get_u8("hunger_max");
			}
		
			params.write_u8(heal_amount);
			blob.set_u8("thirst_current", restored_thirst); //Restore thirst
			blob.Sync("thirst_current", true);
			blob.Untag("is_thirsty");
			blob.set_u8("hunger_current", restored);// restore hunger
			blob.Sync("hunger_current", true);
			blob.Untag("starving");	

			this.SendCommand(this.getCommandID(heal_id), params);	
		
			this.Tag("healed");
		}
}

void onCommand(CBlob@ this, u8 cmd, CBitStream@ params)
{
	if(cmd == this.getCommandID(heal_id))
	{
		this.getSprite().PlaySound( this.get_string( "eat sound") );
		
		if(getNet().isServer())
		{
			u16 blob_id;
			if(!params.saferead_u16(blob_id)) return;
			
			CBlob@ theBlob = getBlobByNetworkID(blob_id);
			if(theBlob !is null)
			{
				u8 heal_amount;
				if(!params.saferead_u8(heal_amount)) return;
				
				if(heal_amount == 255)
				{
					theBlob.server_SetHealth( theBlob.getInitialHealth() );
				}
				else
				{
					theBlob.server_Heal( f32(heal_amount) * 0.25f );
				}
				
			}
			
			this.server_Die();
		}
	}
}

void onCollision( CBlob@ this, CBlob@ blob, bool solid )
{
	if (blob is null) {
		return;
	}
						  
	if (getNet().isServer() && !blob.hasTag("dead")) 
	{
		if(blob.getHealth() < blob.getInitialHealth())
		{
			Heal( this, blob );
		}
	}
}

void onAttach( CBlob@ this, CBlob@ attached, AttachmentPoint @attachedPoint )
{
	if (getNet().isServer()) 
	{
		if(attached.getHealth() < attached.getInitialHealth())
		{
			CBlob@ blob = attached;
			Heal( this, blob );
		}
	}
}

void onDetach( CBlob@ this, CBlob@ detached, AttachmentPoint @attachedPoint )
{
	if (getNet().isServer()) 
	{
		if(detached.getHealth() < detached.getInitialHealth())
		{
			CBlob@ blob = detached;
			Heal( this, blob );
		}
	}
}

